diff --git a/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java b/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
index 8d3d0e2a1..0f231c41a 100644
--- a/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
@@ -7,10 +8,12 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.season.Seasons;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -54,8 +57,11 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
-    {
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
+        return harvest(world, x, y, z, player);
+    }
+
+    public boolean harvest(World world, int x, int y, int z, @Nullable Player player) {
         int meta = world.getBlockMetadata(x, y, z);
         int decayData = meta & 0x0F;
         int growthRate = (meta & 0xF0) >> 4;
@@ -70,7 +76,12 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
             world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CACAO.id, tickDelay());
             return true;
         }
-        return super.onBlockRightClicked(world, x, y, z, player, side, xPlaced, yPlaced);
+        return false;
+    }
+
+    @Override
+    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+        harvest(world, x, y, z, null);
     }
 
     @Override
@@ -100,7 +111,7 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
     }
 
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         int meta = world.getBlockMetadata(blockX, blockY, blockZ);
         if(((meta & 0xF0) >> 4) < 4)
         {
@@ -109,7 +120,7 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
                 if(world.getSeasonManager().getCurrentSeason() != Seasons.OVERWORLD_SUMMER)
                     return true;
                 world.setBlockMetadataWithNotify(blockX, blockY, blockZ, (4 << 4) | meta);
-                if (entityplayer.getGamemode().consumeBlocks())
+                if (player == null || player.getGamemode().consumeBlocks())
                 {
                     itemstack.stackSize--;
                 }
diff --git a/src/main/java/net/minecraft/core/block/CactusBlock.java b/src/main/java/net/minecraft/core/block/CactusBlock.java
index 3734e86a6..5a8134634 100644
--- a/src/main/java/net/minecraft/core/block/CactusBlock.java
+++ b/src/main/java/net/minecraft/core/block/CactusBlock.java
@@ -15,6 +15,7 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -150,11 +151,11 @@ public class CactusBlock extends Block implements IBonemealable
     }
 
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(!world.isClientSide)
         {
             ((CactusBlock)Block.blocksList[id]).growCactusOnTop(world, blockX, blockY, blockZ);
-            if (entityplayer.getGamemode().consumeBlocks())
+            if (player == null || player.getGamemode().consumeBlocks())
             {
                 itemstack.stackSize--;
             }
diff --git a/src/main/java/net/minecraft/core/block/ChestBlock.java b/src/main/java/net/minecraft/core/block/ChestBlock.java
index 638e7035b..9c866fa9e 100644
--- a/src/main/java/net/minecraft/core/block/ChestBlock.java
+++ b/src/main/java/net/minecraft/core/block/ChestBlock.java
@@ -4,16 +4,15 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.ChestBlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.container.CompoundContainer;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 public class ChestBlock extends EntityBlock implements IPaintable {
@@ -23,7 +22,7 @@ public class ChestBlock extends EntityBlock implements IPaintable {
 	}
 	
 	@Override
-	public void onBlockPlacedByMob(World world, int x, int y, int z, Side placeSide, Mob mob, double sideHeight) {
+	public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side placeSide, Mob mob, double sideHeight) {
 		Direction direction = mob.getHorizontalPlacementDirection(placeSide).getOpposite();
 		Type type = Type.SINGLE;
 		
diff --git a/src/main/java/net/minecraft/core/block/ChestBlockPainted.java b/src/main/java/net/minecraft/core/block/ChestBlockPainted.java
index cf08e3e1d..d7453247e 100644
--- a/src/main/java/net/minecraft/core/block/ChestBlockPainted.java
+++ b/src/main/java/net/minecraft/core/block/ChestBlockPainted.java
@@ -8,6 +8,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public class ChestBlockPainted extends ChestBlock implements IPainted {
 
@@ -16,7 +17,7 @@ public class ChestBlockPainted extends ChestBlock implements IPainted {
 	}
 	
 	@Override
-	public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+	public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
 		return stack.getMetadata();
 	}
 
diff --git a/src/main/java/net/minecraft/core/block/CropsPumpkinBlock.java b/src/main/java/net/minecraft/core/block/CropsPumpkinBlock.java
index 025397d92..512446800 100644
--- a/src/main/java/net/minecraft/core/block/CropsPumpkinBlock.java
+++ b/src/main/java/net/minecraft/core/block/CropsPumpkinBlock.java
@@ -10,6 +10,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -125,13 +126,13 @@ public class CropsPumpkinBlock
     }
 
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if (world.getBlockMetadata(blockX, blockY, blockZ) < 5)
         {
             if (!world.isClientSide)
             {
                 ((CropsPumpkinBlock)Blocks.CROPS_PUMPKIN).fertilize(world, blockX, blockY, blockZ);
-                if (entityplayer.getGamemode().consumeBlocks())
+                if (player == null || player.getGamemode().consumeBlocks())
                 {
                     itemstack.stackSize--;
                 }
diff --git a/src/main/java/net/minecraft/core/block/CropsWheatBlock.java b/src/main/java/net/minecraft/core/block/CropsWheatBlock.java
index e46da3a28..2edf0870f 100644
--- a/src/main/java/net/minecraft/core/block/CropsWheatBlock.java
+++ b/src/main/java/net/minecraft/core/block/CropsWheatBlock.java
@@ -11,6 +11,7 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 // Referenced classes of package net.minecraft.src:
 //            FlowerBlock, Block, World, ItemEntity,
@@ -134,13 +135,13 @@ public class CropsWheatBlock extends FlowerBlock implements IBonemealable
     }
 
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(world.getBlockMetadata(blockX, blockY, blockZ) < 7)
         {
             if(!world.isClientSide)
             {
                 ((CropsWheatBlock)Blocks.CROPS_WHEAT).fertilize(world, blockX, blockY, blockZ);
-                if (entityplayer.getGamemode().consumeBlocks())
+                if (player == null || player.getGamemode().consumeBlocks())
                 {
                     itemstack.stackSize--;
                 }
diff --git a/src/main/java/net/minecraft/core/block/DispenserBlock.java b/src/main/java/net/minecraft/core/block/DispenserBlock.java
index fd02b04f7..fc358c38d 100644
--- a/src/main/java/net/minecraft/core/block/DispenserBlock.java
+++ b/src/main/java/net/minecraft/core/block/DispenserBlock.java
@@ -10,20 +10,15 @@ import net.minecraft.core.entity.projectile.*;
 import net.minecraft.core.item.IDispensable;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
-// Referenced classes of package net.minecraft.src:
-//            BlockContainer, Material, Block, World, 
-//            IBlockAccess, DispenserBlockEntity, Player, ItemStack,
-//            Item, ArrowProjectile, EggProjectile, SnowballProjectile,
-//            ItemEntity, Mob, MathHelper, IInventory,
-//            BlockEntity
-
-public class DispenserBlock extends RotatableEntityBlock
+public class DispenserBlock extends VeryRotatableEntityBlock
 {
+    public static final int MASK_POWERED = 0b0000_1000;
 	public DispenserBlock(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.stone);
@@ -35,44 +30,6 @@ public class DispenserBlock extends RotatableEntityBlock
         return 4;
     }
 
-    @Override
-	public void onBlockPlacedByWorld(World world, int x, int y, int z)
-    {
-        super.onBlockPlacedByWorld(world, x, y, z);
-        recalculateLookDirection(world, x, y, z);
-    }
-
-    private void recalculateLookDirection(World world, int x, int y, int z)
-    {
-        if(world.isClientSide)
-        {
-            return;
-        }
-        int l = world.getBlockId(x, y, z - 1);
-        int i1 = world.getBlockId(x, y, z + 1);
-        int j1 = world.getBlockId(x - 1, y, z);
-        int k1 = world.getBlockId(x + 1, y, z);
-        byte byte0 = 3;
-        if(Block.solid[l] && !Block.solid[i1])
-        {
-            byte0 = 3;
-        }
-        if(Block.solid[i1] && !Block.solid[l])
-        {
-            byte0 = 2;
-        }
-        if(Block.solid[j1] && !Block.solid[k1])
-        {
-            byte0 = 5;
-        }
-        if(Block.solid[k1] && !Block.solid[j1])
-        {
-            byte0 = 4;
-        }
-        world.setBlockMetadataWithNotify(x, y, z, byte0);
-    }
-
-
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
@@ -89,78 +46,72 @@ public class DispenserBlock extends RotatableEntityBlock
 
     private void dispenseItem(World world, int x, int y, int z, Random random)
     {
-        int data = world.getBlockMetadata(x, y, z);
-        int xOffset = 0;
-        int zOffset = 0;
-        if (data == 3) {
-            zOffset = 1;
-        } else if (data == 2) {
-            zOffset = -1;
-        } else if (data == 5) {
-            xOffset = 1;
-        } else {
-            xOffset = -1;
-        }
+        Direction direction = VeryRotatableEntityBlock.metaToDirection(world.getBlockMetadata(x, y, z));
+        int xOffset = direction.getOffsetX();
+        int yOffset = direction.getOffsetX();
+        int zOffset = direction.getOffsetZ();
+
         DispenserBlockEntity tileEntity = (DispenserBlockEntity)world.getBlockEntity(x, y, z);
         ItemStack itemStack = tileEntity.getRandomStackFromInventory();
         double px = (double)x + (double)xOffset * 0.6D + 0.5D;
-        double py = (double)y + 0.5D;
+        double py = (double)y + (double)yOffset * 0.6D + 0.5D;
         double pz = (double)z + (double)zOffset * 0.6D + 0.5D;
         if(itemStack == null)
         {
-            world.playSoundEffect(LevelListener.EVENT_DISPENSER_EMPTY, x, y, z, 0);
+            world.playBlockEvent(LevelListener.EVENT_DISPENSER_EMPTY, x, y, z, 0);
         }
         else
         {
             if (itemStack.getItem() instanceof IDispensable)
             {
                 IDispensable dispensable = (IDispensable) itemStack.getItem();
-                dispensable.onDispensed(itemStack, world, px, py, pz, xOffset, zOffset, random);
-                world.playSoundEffect(LevelListener.EVENT_DISPENSER_PROJECTILE, x, y, z, 0);
+                dispensable.onDispensed(itemStack, world, px, py, pz, xOffset, yOffset, zOffset, random);
+                world.playBlockEvent(LevelListener.EVENT_DISPENSER_PROJECTILE, x, y, z, 0);
             }
             else if (itemStack.itemID == Items.AMMO_ARROW.id || itemStack.itemID == Items.AMMO_ARROW_GOLD.id)
             {
 
                 ArrowProjectile arrow = itemStack.itemID == Items.AMMO_ARROW.id ? new ArrowProjectile(world, px, py, pz, 0) : new GoldenArrowProjectile(world, px, py, pz);
-                arrow.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
+                arrow.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
                 arrow.setDoesArrowBelongToPlayer(true);
                 world.entityJoinedWorld(arrow);
-                world.playSoundEffect(LevelListener.EVENT_DISPENSER_PROJECTILE, x, y, z, 0);
+                world.playBlockEvent(LevelListener.EVENT_DISPENSER_PROJECTILE, x, y, z, 0);
             }
             else if (itemStack.itemID == Items.AMMO_CHARGE_EXPLOSIVE.id)
             {
                 CannonballProjectile cannonballProjectile = new CannonballProjectile(world, px, py, pz);
-                cannonballProjectile.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
+                cannonballProjectile.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
                 world.entityJoinedWorld(cannonballProjectile);
-                world.playSoundEffect(LevelListener.EVENT_DISPENSER_PROJECTILE, x, y, z, 0);
+                world.playBlockEvent(LevelListener.EVENT_DISPENSER_PROJECTILE, x, y, z, 0);
             }
             else
             {
                 ItemEntity item = new ItemEntity(world, px, py - 0.3D, pz, itemStack);
                 double randOffset = random.nextDouble() * 0.1D + 0.2D;
                 item.xd = (double)xOffset * randOffset;
-                item.yd = 0.2D;
+                item.yd = (double)yOffset + 0.2D;
                 item.zd = (double)zOffset * randOffset;
                 item.xd += random.nextGaussian() * 0.0075D * 6D;
                 item.yd += random.nextGaussian() * 0.0075D * 6D;
                 item.zd += random.nextGaussian() * 0.0075D * 6D;
                 world.entityJoinedWorld(item);
-                world.playSoundEffect(LevelListener.EVENT_DISPENSER_ITEM, x, y, z, 0);
+                world.playBlockEvent(LevelListener.EVENT_DISPENSER_ITEM, x, y, z, 0);
             }
-            world.playSoundEffect(LevelListener.EVENT_DISPENSER_PARTICLES, x, y, z, xOffset + 1 + (zOffset + 1) * 3);
+            world.playBlockEvent(LevelListener.EVENT_DISPENSER_PARTICLES, x, y, z, xOffset + 1 + (zOffset + 1) * 3);
         }
     }
 
     @Override
-	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        if(blockId > 0 && Block.blocksList[blockId].isSignalSource())
+        boolean flag = world.hasNeighborSignal(x, y, z) || world.hasNeighborSignal(x, y + 1, z);
+        int meta = world.getBlockMetadata(x, y, z);
+        if(flag && (meta & MASK_POWERED) == 0)
         {
-            boolean flag = world.hasNeighborSignal(x, y, z) || world.hasNeighborSignal(x, y + 1, z);
-            if(flag)
-            {
-                world.scheduleBlockUpdate(x, y, z, id, tickDelay());
-            }
+            world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+            world.setBlockMetadata(x, y, z, meta | MASK_POWERED);
+        } else if (!flag){
+            world.setBlockMetadata(x, y, z, meta & ~MASK_POWERED);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/DoorBlock.java b/src/main/java/net/minecraft/core/block/DoorBlock.java
index 0a6469005..a01317bed 100644
--- a/src/main/java/net/minecraft/core/block/DoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/DoorBlock.java
@@ -3,8 +3,10 @@ package net.minecraft.core.block;
 import java.util.Random;
 import java.util.function.Supplier;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.entity.BlockEntity;
@@ -19,6 +21,7 @@ import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 // Referenced classes of package net.minecraft.src:
@@ -52,7 +55,7 @@ public class DoorBlock extends Block implements IPaintable
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
         super.onBlockPlacedByMob(world, x, y, z, side, mob, sideHeight);
 
         int meta = world.getBlockMetadata(x, y, z);
@@ -160,10 +163,15 @@ public class DoorBlock extends Block implements IPaintable
         }
         world.setBlockMetadataWithNotify(x, y, z, l ^ 4);
         world.markBlocksDirty(x, y - 1, z, x, y, z);
-        world.playSoundEffect(player, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
+        world.playBlockEvent(player, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
         return true;
     }
 
+    @Override
+    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+        onBlockRightClicked(world, x, y, z, null, direction.getSide(), 0.5, 0.5);
+    }
+
     public void onPoweredBlockChange(World world, int x, int y, int z, boolean isPowered)
     {
         int l = world.getBlockMetadata(x, y, z);
@@ -189,7 +197,7 @@ public class DoorBlock extends Block implements IPaintable
         }
         world.setBlockMetadataWithNotify(x, y, z, l ^ 4);
         world.markBlocksDirty(x, y - 1, z, x, y, z);
-        world.playSoundEffect(null, 1003, x, y, z, 0);
+        world.playBlockEvent(null, 1003, x, y, z, 0);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/FarmlandBlock.java b/src/main/java/net/minecraft/core/block/FarmlandBlock.java
index 04fdfdcbd..29085bf58 100644
--- a/src/main/java/net/minecraft/core/block/FarmlandBlock.java
+++ b/src/main/java/net/minecraft/core/block/FarmlandBlock.java
@@ -13,6 +13,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -180,7 +181,7 @@ public class FarmlandBlock extends Block implements IBonemealable
 	}
 
 	@Override
-	public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		int data = world.getBlockMetadata(blockX, blockY, blockZ);
 		if (!isFertilized(data)) {
 			world.setBlockMetadataWithNotify(blockX, blockY, blockZ, setFertilized(data, true));
diff --git a/src/main/java/net/minecraft/core/block/FenceGateBlock.java b/src/main/java/net/minecraft/core/block/FenceGateBlock.java
index 65998b750..8630ba6e4 100644
--- a/src/main/java/net/minecraft/core/block/FenceGateBlock.java
+++ b/src/main/java/net/minecraft/core/block/FenceGateBlock.java
@@ -1,17 +1,22 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
 public class FenceGateBlock extends Block implements IPaintable
 {
 
@@ -78,7 +83,7 @@ public class FenceGateBlock extends Block implements IPaintable
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
     	int directionmeta = mob.getHorizontalPlacementDirection(side).getHorizontalIndex();
         int colormeta = world.getBlockMetadata(x, y, z);
         world.setBlockMetadataWithNotify(x, y, z, directionmeta | (colormeta & 0xF0));
@@ -92,7 +97,7 @@ public class FenceGateBlock extends Block implements IPaintable
     }
     
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, @Nullable Player player, Side side, double xPlaced, double yPlaced)
     {
         int l = world.getBlockMetadata(x, y, z);
         if(func_35291_d(l))
@@ -100,7 +105,10 @@ public class FenceGateBlock extends Block implements IPaintable
             world.setBlockMetadataWithNotify(x, y, z, l & -5);
         } else
         {
-            int i1 = (MathHelper.floor((double)((player.yRot * 4F) / 360F) + 0.5D) & 3) % 4;
+            int i1 = 0;
+            if (player != null) {
+                i1 = (MathHelper.floor((double)((player.yRot * 4F) / 360F) + 0.5D) & 3) % 4;
+            }
             int j1 = func_35290_f(l);
             if(j1 == (i1 + 2) % 4)
             {
@@ -118,6 +126,11 @@ public class FenceGateBlock extends Block implements IPaintable
         return true;
     }
 
+    @Override
+    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+        onBlockRightClicked(world, x, y, z, null, direction.getSide(), 0.5, 0.5);
+    }
+
     public static boolean func_35291_d(int i)
     {
         return (i & 4) != 0;
diff --git a/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java b/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
index 173a92ab7..5e3ed709d 100644
--- a/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
+++ b/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
@@ -92,7 +92,7 @@ public class FireflyLanternBlock extends Block{
         return true;
     }
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
         if ((side == Side.BOTTOM || (side != Side.TOP && sideHeight >= 0.5d)) && (world.isBlockNormalCube(x, y+1, z) || Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))){
             world.setBlockMetadataWithNotify(x, y, z, 1);
             return;
diff --git a/src/main/java/net/minecraft/core/block/FlowerBlock.java b/src/main/java/net/minecraft/core/block/FlowerBlock.java
index d6386bddf..a5a25e320 100644
--- a/src/main/java/net/minecraft/core/block/FlowerBlock.java
+++ b/src/main/java/net/minecraft/core/block/FlowerBlock.java
@@ -11,6 +11,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -38,7 +39,7 @@ public class FlowerBlock extends Block implements IBonemealable {
     }
 
     @Override
-    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
         return MASK_PERMANENT;
     }
 
@@ -103,10 +104,10 @@ public class FlowerBlock extends Block implements IBonemealable {
     }
 
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         Random rand = world.rand;
         if (!world.isClientSide && canBeBonemealed) {
-            if (entityplayer.getGamemode().consumeBlocks()) {
+            if (player == null || player.getGamemode().consumeBlocks()) {
                 itemstack.stackSize--;
             }
             label0:
diff --git a/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java b/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
index ae7bb152f..1f0d820a3 100644
--- a/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
@@ -1,14 +1,17 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.season.Seasons;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -41,6 +44,10 @@ public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBo
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
+        return harvest(world, x, y, z, player);
+    }
+
+    public boolean harvest(World world, int x, int y, int z, @Nullable Player player) {
         int meta = world.getBlockMetadata(x, y, z);
         int decayData = meta & MASK_DECAY_DATA;
         int growthRate = getGrowthRate(meta);
@@ -55,8 +62,12 @@ public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBo
             world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id, tickDelay());
             return true;
         }
-        return super.onBlockRightClicked(world, x, y, z, player, side, xPlaced, yPlaced);
+        return false;
+    }
 
+    @Override
+    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+        harvest(world, x, y, z, null);
     }
 
     @Override
@@ -80,7 +91,7 @@ public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBo
     }
 
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         int meta = world.getBlockMetadata(blockX, blockY, blockZ);
         if(((meta & 0xF0) >> 4) == 0)
         {
@@ -89,7 +100,7 @@ public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBo
                 if(world.getSeasonManager().getCurrentSeason() != Seasons.OVERWORLD_SPRING)
                     return true;
                 world.setBlockMetadataWithNotify(blockX, blockY, blockZ, (1 << 4) | meta);
-                if (entityplayer.getGamemode().consumeBlocks())
+                if (player == null || player.getGamemode().consumeBlocks())
                 {
                     itemstack.stackSize--;
                 }
